VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "VBHWND"
   ClientHeight    =   3975
   ClientLeft      =   1560
   ClientTop       =   1455
   ClientWidth     =   5385
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Moveable        =   0   'False
   ScaleHeight     =   3975
   ScaleWidth      =   5385
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   3000
      TabIndex        =   2
      Top             =   1560
      Width           =   2295
   End
   Begin VB.CheckBox chkOnTop 
      Caption         =   "Always on top"
      Height          =   255
      Left            =   3000
      TabIndex        =   11
      Top             =   600
      Width           =   1935
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "Action"
      Default         =   -1  'True
      Height          =   495
      Left            =   3000
      TabIndex        =   1
      Top             =   960
      Width           =   2295
   End
   Begin VB.Frame frmSelect 
      Caption         =   "Select Action :"
      Height          =   3375
      Left            =   120
      TabIndex        =   0
      Top             =   480
      Width           =   2775
      Begin VB.OptionButton optRight 
         Caption         =   "Move Window Right 50 Pixels"
         Height          =   255
         Left            =   120
         TabIndex        =   10
         Top             =   2880
         Width           =   2535
      End
      Begin VB.OptionButton optLeft 
         Caption         =   "Move Window Left 50 Pixels"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   2520
         Width           =   2535
      End
      Begin VB.OptionButton optShrink 
         Caption         =   "Shrink Window 50 Pixels"
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   2160
         Width           =   2535
      End
      Begin VB.OptionButton optEnlarge 
         Caption         =   "Enlarge Window 50 Pixels"
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   1800
         Width           =   2535
      End
      Begin VB.OptionButton optRestore 
         Caption         =   "Restore Window"
         Height          =   255
         Left            =   120
         TabIndex        =   6
         Top             =   1440
         Width           =   2535
      End
      Begin VB.OptionButton optMaximize 
         Caption         =   "Maximize Window"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   1080
         Width           =   2535
      End
      Begin VB.OptionButton optMinimize 
         Caption         =   "Minimize Window"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   720
         Width           =   2535
      End
      Begin VB.OptionButton optFlash 
         Caption         =   "Flash Window"
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   360
         Value           =   -1  'True
         Width           =   2415
      End
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "This shows how to control VB form from Win API."
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   222
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   120
      TabIndex        =   12
      Top             =   120
      Width           =   5175
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Declare Function FlashWindow Lib "user32" _
                        (ByVal hwnd As Long, _
                         ByVal bInvert As Long) As Long

Private Declare Function SetWindowPos Lib "user32" _
                        (ByVal hwnd As Long, _
                         ByVal hWndInsertAfter As Long, _
                         ByVal x As Long, _
                         ByVal y As Long, _
                         ByVal cx As Long, _
                         ByVal cy As Long, _
                         ByVal wFlags As Long) As Long
Const SWP_NOSIZE = &H1
Const SWP_NOMOVE = &H2
Const SWP_SHOWWINDOW = &H40
Const SWP_NOZORDER = &H4
Const HWND_TOPMOST = -1
Const HWND_NOTOPMOST = -2

Private Declare Function ShowWindow Lib "user32" _
                        (ByVal hwnd As Long, _
                         ByVal nCmdShow As Long) As Long
Const SW_NORMAL = 1
Const SW_MINIMIZE = 2
Const SW_MAXIMIZE = 3
Const SW_RESTORE = 9

Private Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type
Private Declare Function GetWindowRect Lib "user32" _
                        (ByVal hwnd As Long, _
                         lpRect As RECT) As Long

Private Sub chkOnTop_Click()
    If chkOnTop.Value = 1 Then
        Call SetWindowPos(Me.hwnd, HWND_TOPMOST, 0, 0, 0, 0, _
                    SWP_NOMOVE Or SWP_NOSIZE Or SWP_SHOWWINDOW)
    Else
        Call SetWindowPos(Me.hwnd, HWND_NOTOPMOST, 0, 0, 0, 0, _
                    SWP_NOMOVE Or SWP_NOSIZE Or SWP_SHOWWINDOW)
    End If
End Sub

Private Sub cmdAction_Click()
    If optFlash.Value = True Then
        FlashForm
    End If
    If optMinimize.Value = True Then
        MinimizeForm
    End If
    If optMaximize.Value = True Then
        MaximizeForm
    End If
    If optRestore.Value = True Then
        RestoreForm
    End If
    If optEnlarge.Value = True Then
        ResizeForm 50, 50
    End If
    If optShrink.Value = True Then
        ResizeForm -50, -50
    End If
    If optLeft.Value = True Then
        MoveForm -50
    End If
    If optRight.Value = True Then
        MoveForm 50
    End If
End Sub

Sub FlashForm()
    Dim I As Long
    
    For I = 1 To 10
        Call FlashWindow(Me.hwnd, -1)
        Sleep (500)
    Next I
    Call FlashWindow(Me.hwnd, 0)
End Sub

Sub MinimizeForm()
    Call ShowWindow(Me.hwnd, SW_MINIMIZE)
End Sub

Sub MaximizeForm()
    Call ShowWindow(Me.hwnd, SW_MAXIMIZE)
End Sub

Sub RestoreForm()
    Call ShowWindow(Me.hwnd, SW_RESTORE)
End Sub

Sub ResizeForm(dw As Long, dh As Long)
    Dim W As RECT
    
    Call GetWindowRect(Me.hwnd, W)
    W.Right = W.Right + dw
    W.Bottom = W.Bottom + dh
    Call SetWindowPos(Me.hwnd, 0, 0, 0, _
                W.Right - W.Left, W.Bottom - W.Top, _
                SWP_NOMOVE Or SWP_SHOWWINDOW Or SWP_NOZORDER)
End Sub

Sub MoveForm(dx As Long)
    Dim W As RECT
    
    Call GetWindowRect(Me.hwnd, W)
    W.Left = W.Left + dx
    Call SetWindowPos(Me.hwnd, 0, W.Left, W.Top, 0, 0, _
                SWP_NOSIZE Or SWP_SHOWWINDOW Or SWP_NOZORDER)
End Sub

Private Sub cmdExit_Click()
    End
End Sub
